import Path from './Path';
var traverse = function (node, visitors, parentPath) {
    // Create a path
    var path = new Path(node, parentPath);
    // Entering node
    visitors.forEach(function (visitor) {
        var _a, _b;
        (_b = (_a = visitor[path.node.type]) === null || _a === void 0 ? void 0 : _a.enter) === null || _b === void 0 ? void 0 : _b.call(_a, path);
    });
    // Possible sub nodes
    switch (path.node.type) {
        case 'Array':
            path.node.elements.forEach(function (node) {
                traverse(node, visitors, path);
            });
            break;
        case 'Object':
            path.node.entries.forEach(function (node) {
                traverse(node, visitors, path);
            });
            break;
        case 'ObjectEntry':
            traverse(path.node.value, visitors, path);
    }
    // Exiting node
    visitors.forEach(function (visitor) {
        var _a, _b;
        (_b = (_a = visitor[path.node.type]) === null || _a === void 0 ? void 0 : _a.exit) === null || _b === void 0 ? void 0 : _b.call(_a, path);
    });
    return path;
};
export default traverse;
