var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./Path"], factory);
    }
})(function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var Path_1 = __importDefault(require("./Path"));
    var traverse = function (node, visitors, parentPath) {
        // Create a path
        var path = new Path_1["default"](node, parentPath);
        // Entering node
        visitors.forEach(function (visitor) {
            var _a, _b;
            (_b = (_a = visitor[path.node.type]) === null || _a === void 0 ? void 0 : _a.enter) === null || _b === void 0 ? void 0 : _b.call(_a, path);
        });
        // Possible sub nodes
        switch (path.node.type) {
            case 'Array':
                path.node.elements.forEach(function (node) {
                    traverse(node, visitors, path);
                });
                break;
            case 'Object':
                path.node.entries.forEach(function (node) {
                    traverse(node, visitors, path);
                });
                break;
            case 'ObjectEntry':
                traverse(path.node.value, visitors, path);
        }
        // Exiting node
        visitors.forEach(function (visitor) {
            var _a, _b;
            (_b = (_a = visitor[path.node.type]) === null || _a === void 0 ? void 0 : _a.exit) === null || _b === void 0 ? void 0 : _b.call(_a, path);
        });
        return path;
    };
    exports["default"] = traverse;
});
